<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: function.php
# Path: admin/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined('SN_SiteSystemAdmin')) { Header('Location: ../index.php'); exit; }

// Запись настроек системы/модулей/блоков
function save_config ($cfg, $name='', $type='module') {
   $type_conf = array (
      'system' => SN_PathRoot.'inc/configs/system.php',
      'module' => SN_PathRoot.'inc/configs/'.(($name == '')? SN_ModuleName : $name).'-mod.php',
      'block' => SN_PathRoot.'inc/configs/'.$name.'-block.php',
      );
   if ((!isset ($type_conf[$type])) AND (!is_array ($cfg))) { return false; }
   if ($file = @fopen ($type_conf[$type], 'w')) {
       while (!flock ($file, 2)) {
          sleep (1);
          $i++;
          if ($i >= 8) { return false; }
       }
      @fwrite ($file, '<?die;?>'.serialize ($cfg));
      @fclose ($file);
      return true;
   }
   return false;
}

// Чтение информации о модуле/блоке из его ini файла
function load_ini ($index= '', $name='', $type='module') {
   $type_conf = array (
      'system' => SN_PathRoot.'inc/info.php',
      'module' => SN_PathRootAdmin.'modules/'.(($name == '')? SN_ModuleName : $name).'/core/info.php',
      'block' => SN_PathRoot.'blocks/'.$name.'/info.php',
      );
   if ((!isset ($type_conf[$type])) || !file_exists ($type_conf[$type])) { return array (); }
   $ini = parse_ini_file ($type_conf[$type], true);
   if ('' == $index) { return $ini; }
   if (('' != $index) && (isset ($ini[$index]))) { return $ini[$index]; }
   return array ();
}
# SchoolNuke 2:
// функция админа для навигации в поиске
function insearch ($url) {
//    $s_array['search'] = $search = trim (strip_tags ((isset($_POST['search'])) ? $_POST['search'] : ((isset($_GET['search'])) ? $_GET['search'] : false)));
//    $s_array['critery'] = $critery = trim (strip_tags ((isset($_POST['critery'])) ? $_POST['critery'] : ((isset($_GET['critery'])) ? $_GET['critery'] : false)));
    $s_array['search'] = $search = trim (strip_tags ((isset($_REQUEST['search'])) ? $_REQUEST['search'] : false));
    $s_array['critery'] = $critery = trim (strip_tags ((isset($_REQUEST['critery'])) ? $_REQUEST['critery'] : false));
    $s_array['form'] = ($search && $critery) ? url($url.'&in=search&search='.$search.'&critery='.$critery): url($url);
    $s_array['add'] = ($search && $critery) ? '&search='.$search.'&critery='.$critery: '';
    $s_array['input'] = ($search && $critery) ? '<input type="hidden" name="search" value="'.$search.'"><input type="hidden" name="critery" value="'.$critery.'">': "";	   
    $s_array['result'] = ($search && $critery) ? '&in=good&search='.$search.'&critery='.$critery : '&in=good';
    $s_array['good'] = ($search && $critery) ? '<input type="hidden" name="in" value="search"><input type="hidden" name="search" value="'.$search.'"><input type="hidden" name="critery" value="'.$critery.'">': '';	   
	return $s_array;
}

function check_admin ($login, $password, $password2, $email, $admin_fullname, $admin_id=0) {
    global $eror_reg, $db, $conf;
    
    if ((strlen($login) > 15) || (strlen($login) < 3)) $eror_reg = _NICK2LONG;
	if ((!$login) || ($login=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$login))) $eror_reg = _ERRORINVNICK;
	if ($db->sql_numrows($db->sql_query("SELECT login FROM ".SN_TABLE_ADMINS." WHERE admin_id <> '".$admin_id."' AND login='".$login."'")) > 0) $eror_reg = _NICKTAKEN;
    if (strrpos($login,' ') > 0) $eror_reg = _NICKNOSPACES;
    if (strlen($password) < 6) $eror_reg = _PASSWORDLONG;
	if ((!$password) || ($password=="")) $eror_reg = _ERRORINVPASSWORD;
	if ($password != $password2) $eror_reg = _ERRORCHEKPASSWORD;
    if ($conf['reg_user_method'] == 1) {	
       if ((!$email) || ($email=="") || (!eregi("^[a-zA-Z0-9_.-]+@(([a-zA-Z0-9-]+\.)+)([a-zA-Z]{2,4})$",$email))) $eror_reg = _ERRORINVEMAIL;
       if ($db->sql_numrows($db->sql_query("SELECT email FROM ".SN_TABLE_ADMINS." WHERE admin_id <> '".$admin_id."' AND email='".$email."'")) > 0) $eror_reg = _EMAILREGISTERED;
       if (strrpos($email,' ') > 0) $eror_reg = _ERROREMAILSPACES;
    }
   	if ((!$admin_fullname) || ($admin_fullname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$admin_fullname))) $eror_reg = _ERRORINVUSERFULLNAME;
    if ((strlen($admin_fullname) > 80) || (strlen($admin_fullname) < 10)) $eror_reg = _USERFULLNAME2LONG;

	return($eror_reg);
}

function check_member ($username, $group_id, $user_email, $user_fullname, $user_id=0) {
    global $eror_reg, $db, $conf;
    
    if ((strlen($username) > 20) || (strlen($username) < 3)) $eror_reg = _NICK2LONG;
	if ((!$username) || ($username=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$username))) $eror_reg = _ERRORINVNICK;
	if ($db->sql_numrows($db->sql_query("SELECT username FROM ".SN_MEMBERS_TABLE." WHERE user_id <> '".$user_id."' AND username='".$username."'")) > 0) $eror_reg = _NICKTAKEN;
    if (preg_match("[^((root)|(adm)|(webmaster)|(admin)|(god)|(administrator)|(administrador)|(Админ)|(Администратор)|(Оператор)|(Модератор)|(operator))$]u",$username)) $eror_reg = _NAMERESERVED;
    if (strrpos($username,' ') > 0) $eror_reg = _NICKNOSPACES;
	if ((!$group_id) || ($group_id=="")) $eror_reg = _ERRORINVUSERGROUP;
    if ($conf['reg_user_method'] == 1) {		
       if ((!$user_email) || ($user_email=="") || (!eregi("^[a-zA-Z0-9_.-]+@(([a-zA-Z0-9-]+\.)+)([a-zA-Z]{2,4})$",$user_email))) $eror_reg = _ERRORINVEMAIL;
       if ($db->sql_numrows($db->sql_query("SELECT user_email FROM ".SN_MEMBERS_TABLE." WHERE user_id <> '".$user_id."' AND user_email='".$user_email."'")) > 0) $eror_reg = _EMAILREGISTERED;
       if (strrpos($user_email,' ') > 0) $eror_reg = _ERROREMAILSPACES;
    }
   	if ((!$user_fullname) || ($user_fullname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$user_fullname))) $eror_reg = _ERRORINVUSERFULLNAME;
    if ((strlen($user_fullname) > 80) || (strlen($user_fullname) < 10)) $eror_reg = _USERFULLNAME2LONG;

	return($eror_reg);
}

function check_level ($levels, $levelname, $curriculum, $lesson, $skriptname, $level_id=0) {
    global $eror_reg, $db, $conf;
    
	if (($curriculum > 11) || ($curriculum < 1)) $eror_reg = _ERRORINVLEVELCURRICULUM;
    if ((!$skriptname) || ($skriptname=="") || (preg_match("[^a-zA-Z0-9_.-]u",$skriptname))) $eror_reg = _ERRORINVSKRIPTNAME;
   	if ((!$levelname) || ($levelname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$levelname))) $eror_reg = _ERRORINVNAME;
	if ($db->sql_numrows($db->sql_query("SELECT levelname FROM ".SN_LEVEL_TABLE." WHERE level_id <> ".$level_id." AND levelname ='".$levelname."'")) > 0) $eror_reg = _LEVELSNAMETAKEN;
    if ((strlen($levelname) > 50) || (strlen($levelname) < 5)) $eror_reg = _LEVELNAME2LONG;
	if ((!$levels) || ($levels=="") || (!is_int($levels))) $eror_reg = _ERRORINVLEVELS;
	if ($db->sql_numrows($db->sql_query("SELECT levels FROM ".SN_LEVEL_TABLE." WHERE level_id <> ".$level_id." AND levels='".$levels."' AND curriculum='".$curriculum."' AND lesson='".$lesson."'")) > 0) $eror_reg = _LEVELSTAKEN;

	return($eror_reg);
}

function check_lesson ($lesson, $lessonname, $lesson_id=0) {
    global $eror_reg, $db, $conf;

	if ((!$lesson) || ($lesson=="") || (ereg("[^a-zA-Z0-9]",$lesson))) $eror_reg = _ERRORINVSHORT;
    if ($db->sql_numrows($db->sql_query("SELECT lesson FROM ".SN_LESSON_TABLE." WHERE lesson_id <> '".$lesson_id."' AND lesson='".$lesson."'")) > 0) $eror_reg = _SHORREGISTERED;
    if ((!$lessonname) || ($lessonname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$lessonname))) $eror_reg = _ERRORINVNAME;
	if ($db->sql_numrows($db->sql_query("SELECT lessonname FROM ".SN_LESSON_TABLE." WHERE lesson_id <> '".$lesson_id."' AND lessonname='".$lessonname."'")) > 0) $eror_reg = _NAMETAKEN;
    if (strrpos($lesson,' ') > 0) $eror_reg = _ERRORSHORSPACES;
	if ((strlen($lesson) > 5) || (strlen($lesson) < 2)) $eror_reg = _SHOR2LONG;
    if ((strlen($lessonname) > 50) || (strlen($lessonname) < 5)) $eror_reg = _NAME2LONG;

    return($eror_reg);
}

function check_group ($groups, $curriculum, $groupname, $group_id=0) {
    global $eror_reg, $db, $conf;

	if ((!$groups) || ($groups=="") || (ereg("[^a-zA-Z0-9_.-]",$groups))) $eror_reg = _ERRORINVGROUPS;
    if (($db->sql_numrows($db->sql_query("SELECT groups FROM ".SN_GROUP_TABLE." WHERE group_id <> '".$group_id."' AND groups='".$groups."'"))) > 0) $eror_reg = _GROUPSREGISTERED;
	if (strrpos($groups,' ') > 0) $eror_reg = _ERRORGROUPSPACES;
	if ((strlen($groups) > 7) || (strlen($groups) < 3)) $eror_reg = _GROUPS2LONG;
	if (($curriculum > 11) || ($curriculum < 1)) $eror_reg = _CURRICULUM2LONG;
	if ((!$groupname) || ($groupname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$groupname))) $eror_reg = _ERRORINVGROUPNAME;
	if ($db->sql_numrows($db->sql_query("SELECT groupname FROM ".SN_GROUP_TABLE." WHERE group_id <> '".$group_id."' AND groupname='".$groupname."'")) > 0) $eror_reg = _GROUPNAMETAKEN;
    if ((strlen($groupname) > 40) || (strlen($groupname) < 5)) $eror_reg = _GROUPNAME2LONG;

    return($eror_reg);
}

function check_table ($tablename, $tablefullname, $lesson, $curriculum) {
    global $eror_reg, $db, $conf;
    
	if ((!$tablename) || ($tablename=="") || (preg_match("[^a-zA-Z0-9]u",$tablename))) $eror_reg = _ERRORINVTABLENAME;
	if ($db->sql_numrows($db->sql_query("SELECT tablename FROM ".SN_TABLE_TABLE." WHERE tablename='$tablename'")) > 0) $eror_reg = _TABLENAMETAKEN;
    if ((strlen($tablename) > 5) || (strlen($tablename) < 3)) $eror_reg = _TABLENAME2LONG;
    if (strrpos($tablename,' ') > 0) $eror_reg = _TABLENAMENOSPACES;
	if ((!$tablefullname) || ($tablefullname=="") || (preg_match("[^a-zA-Zа-яА-Я0-9_.-]u",$tablefullname))) $eror_reg = _ERRORINVTABLEFULLNAME;
    if ((strlen($tablefullname) > 30) || (strlen($tablefullname) < 10)) $eror_reg = _TABLEFULLNAME2LONG;
	if ((!$lesson) || ($lesson=="")) $eror_reg = _ERRORINVTABLELESSON;
   	if ((!$curriculum) || ($curriculum=="") || (preg_match("[^0-9]u",$curriculum))) $eror_reg = _ERRORINVETABLECURRICULUM;
    if (($curriculum > 11) || ($curriculum < 1)) $eror_reg = _TABLECURRICULUM2LONG;

	return($eror_reg);
}
//end

?>