<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: header.php
# Path: /
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: header.php
# Path: /
# Version: 2.0.4
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: index.php'); exit; }

global $conf, $template, $user, $header_mod_title, $header_page_title, $header_page_keyword, $module;

// Charset
header ('Content-Type: text/html; charset='._CHARSET);
// Upgrade Date & Expires
header ('Last-Modified: '.gmdate ('D, d M Y H:i:s').' GMT');
header ('Expires: '.gmdate ('D, d M Y H:i:s').' GMT');
// Cache-control
header('Cache-Control: no-store, no-cache, must-revalidate');  // HTTP/1.1
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

if (isset ($header_page_keyword)) {
   $keywords = strip_tags ($header_page_keyword);
   $keywords = trim (ereg_replace ('("|\?|!|:|\.|\(|\)|;|\\\\)+', ' ', $keywords));
   $keywords = ereg_replace ('( |'.CHR(10).'|'.CHR(13).')+', ',', $keywords);
   $keywords = substr ($keywords, 0, 1000);
   $keywords = explode (",", $keywords);
   $key_words = $conf['site_keywords'];
   for ($i=0; $i<count ($keywords)-1; $i++) {
      if (strlen ($keywords[$i]) > 3) { $key_words .= ", $keywords[$i]"; }
   }
} else {
   $key_words = $conf['site_keywords'];
}

// Echo header tags
echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'
    .'<html>'
    .'<head>'
    .'<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset='._CHARSET.'">'
    .'<META HTTP-EQUIV="Expires" CONTENT="'.gmdate ('D, d M Y H:i:s').' GMT'.'">'
    .'<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">'
    .'<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    .'<META NAME="RESOURCE-TYPE" CONTENT="DOCUMENT">'
    .'<META NAME="DISTRIBUTION" CONTENT="GLOBAL">'
    .'<META NAME="AUTHOR" CONTENT="'.$conf['site_name'].'">'
    .'<META NAME="COPYRIGHT" CONTENT="Copyright (c) by '.$conf['site_name'].'">'
    .'<META NAME="ROBOTS" CONTENT="INDEX, FOLLOW">'
    .'<META NAME="REVISIT-AFTER" CONTENT="1 DAYS">'
    .'<META NAME="RATING" CONTENT="GENERAL">'
    .'<META NAME="KEYWORDS" CONTENT="'.$key_words.'">'
    .'<META NAME="DESCRIPTION" CONTENT="'.$conf['site_description'].'">'
    .'<LINK REL="icon" HREF="'.((file_exists(SN_PathRoot.'template/'.$conf['default_design'].'/favicon.ico')) ? "template/".$conf['default_design']."/" : "").'favicon.ico" TYPE="image/x-icon">'
    .'<LINK REL="shortcut icon" HREF="'.((file_exists(SN_PathRoot.'template/'.$conf['default_design'].'/favicon.ico')) ? "template/".$conf['default_design']."/" : "").'favicon.ico" TYPE="image/x-icon">'
    .'<LINK REL="stylesheet" HREF="template/'.$conf['default_design'].'/style.css" TYPE="text/css">';
	
if (file_exists (SN_PathRoot.'template/'.$conf['default_design'].'/styles/'.$module['name'].'.css')) {
    echo '<LINK REL="stylesheet" HREF="template/'.$conf['default_design'].'/styles/'.$module['name'].'.css" TYPE="text/css">
    ';
}
if (_SNSS_HOME == 1) {
   echo '<title>'.$conf['site_name'].' | '.$conf['site_description'].'</title>';
} else {
   if (isset ($header_page_title)) {
      echo '<title>'.$conf['site_name'].' | '.$header_mod_title.' | '.$header_page_title.'</title>';
   } else {
      echo '<title>'.$conf['site_name'].' | '.$header_mod_title.'</title>';
   }
}

include (SN_PathRoot.'inc/java_scripts.js');
echo '</head>';

$template->set_filenames (array (
   'page_header' => 'page_header.tpl'
   ));

if ($conf['multi_lang'] == 1) {
    $handle = opendir (SN_PathRoot.'lang');
    while (false !== ($file = readdir ($handle))) {
        $rowlang = substr ($file, 5, strlen ($file)-9);
        if ($file === ('lang-'.$rowlang.'.php')) {
         $template->assign_block_vars ('language', array (
            'LANG_LINKS' => 'index.php?newlang='.$rowlang,
            'LANG_FLAGS' => $rowlang,
            ));
        }
    }
    closedir ($handle);
    unset ($handle, $file, $rowlang);
}

if (1 == $conf['register_user']) {
   if (0 < $user['user_id']) {
      $template->assign_block_vars ('user', array (
         'L_WELCOME' => _WELCOME,
         'MEMBER_LOGIN' => $user['member_login'],
         'S_MEMBER_ACCOUNT' => 'index.php?go=Members',
         'L_EXIT_LOGIN' => _EXIT,
         'S_EXIT_LOGIN' => 'index.php?logout'
         ));
   } else {
      $template->assign_block_vars ('anonym', array (
         'L_WELCOME' => _WELCOME,
         'MEMBER_LOGIN' => _ANONYM,
         'S_MEMBER_ACCOUNT' => 'index.php?go=Members',
         'L_MEMBER_ACCOUNT' => _AUTHORIZATION,
         'L_NEWREG' => _REGISTRATION,
         'S_NEWREG' => 'index.php?go=Members&amp;in=new_user'
         ));
   }
}

$template->assign_vars (array(
   'C_SPAN' => (_SNSS_THEME & SN_BLOCK_HEADER) ? ((bool)(_SNSS_THEME & SN_BLOCK_LEFT)*2+(bool)(_SNSS_THEME & SN_BLOCK_RIGHT)*2+1) : '',
   'C_BLOCK' => (_SNSS_THEME & SN_BLOCK_HEADER) ? 'block-header' : ((_SNSS_THEME & SN_BLOCK_LEFT) ? 'block-left' : 'block-center'),
   ));
$template->pparse ('page_header');

if (_SNSS_THEME & SN_BLOCK_HEADER) {
   block ('h');

   $template->set_filenames (array (
      'page_top' => 'page_top.tpl'
      ));
   $template->assign_vars (array (
      'C_BLOCK' => (_SNSS_THEME & SN_BLOCK_LEFT) ? 'block-left' : 'block-center',
      ));
   $template->pparse ('page_top');
}

if (_SNSS_THEME & SN_BLOCK_LEFT) {
   block ('l');

   $template->set_filenames (array (
      'page_left' => 'page_left.tpl'
      ));
   $template->assign_vars (array (
      'C_BLOCK' => 'block-center',
      ));
   $template->pparse ('page_left');
}

block ('t');
title ();
?>