<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: common.php
# Path: inc/
# Version: 2.0.4
######################################################################
if ((!defined ('SN_SiteSystem')) AND (!defined ('SN_SiteSystemAdmin'))) { Header ('Location: ../index.php'); exit; }

include (SN_PathRoot.'inc/php.ini.php');

// Зашита глобальных переменых от слияния когда register_globals включен
if (@ini_get ('register_globals') == '1' || strtolower (@ini_get('register_globals')) == 'on') {
   $not_unset = array ('_GET', '_POST', '_COOKIE', '_SERVER', '_SESSION', '_ENV', '_FILES');
   if (!isset ($_SESSION) || !is_array ($_SESSION)) { $_SESSION = array(); }
   $input = array_merge ($_GET, $_POST, $_COOKIE, $_SERVER, $_SESSION, $_ENV, $_FILES);
   unset ($input['input']);
   unset ($input['not_unset']);
   while (list ($var,) = @each ($input)) { if (!in_array ($var, $not_unset)) { unset ($$var); } }
   unset ($input);
}
/*// Защита от магических кавычек, когда всетки не удается их выключить.
if (get_magic_quotes_gpc()) {
    $_GET = array_map('stripslashes', $_GET);
    $_POST = array_map('stripslashes', $_POST);
    $_COOKIE = array_map('stripslashes', $_COOKIE);
}
*/

$db_conf = array ();
$conf = array ();
$user = array ();
$module = array ();
$blocks = array ();
$session = array ();

// Инициализация начальной конфигурации
if (!file_exists (SN_PathRoot.'inc/config.php')) {
    Header ('Location: '.((defined ('SN_SiteSystemAdmin')) ? '../' : '').'install/install.php');
    exit;
}
include_once (SN_PathRoot.'inc/config.php');
if (!defined ('SN_INSTALLED')) {
    Header ('Location: '.((defined ('SN_SiteSystemAdmin')) ? '../' : '').'install/install.php');
    exit;
}
if (defined ('SN_SiteSystemAdmin')) {
    define ('SN_PathAdmin', $conf['Admin'].'/');
}

$db_conf = $conf;
include_once (SN_PathRoot.'inc/constants.php');
include (SN_PathRoot.'inc/function/function.php');

// Инициализация общей конфигурации
if (!($conf = load_config ('', 'system'))) {
    die ('<br><br><b>ОШИБКА!</b><br><br>Не удалось произвести чтение данных в конфигурационный файл!');
}
error_reporting ($conf['eror_value']);
//define ('SN_UrlRoot', str_replace ('//', '/', $conf['site_url'].$conf['site_path']));
define ('SN_UrlRoot', $conf['site_url'].$conf['site_path']);
if (defined ('SN_SiteSystemAdmin')) {
    define ('SN_PathRootAdmin', SN_PathRoot.SN_PathAdmin);
    define ('SN_UrlRootAdmin', SN_UrlRoot.SN_PathAdmin);
}

// Инициализация пользовательских начальных параметров
$user['user_agent'] = (isset ($_SERVER['HTTP_USER_AGENT'])) ? substr (trim ($_SERVER['HTTP_USER_AGENT']), 0, 100) : '';
$user['user_ip']  = substr ((isset ($_SERVER['HTTP_X_FORWARDED_FOR'])) ? trim ($_SERVER['HTTP_X_FORWARDED_FOR']) : ((isset ($_SERVER['HTTP_CLIENT_IP'])) ? trim ($_SERVER['HTTP_CLIENT_IP']) : trim ($_SERVER['REMOTE_ADDR'])), 0, 16);
//$user['user_host']  = gethostbyaddr($user['user_ip']);
$user['user_host']  = '';
if ($user['user_agent'] == "" || $user['user_agent'] == "-") { exit; }

// Инициализация базы данных
switch ($db_conf['dbtype']) {
case 'mysql':
   include (SN_PathRoot.'inc/db/mysql.php');
   break;
case 'mysql4':
   include (SN_PathRoot.'inc/db/mysql4.php');
   break;
case 'postgres':
   include (SN_PathRoot.'inc/db/postgres7.php');
   break;
case 'mssql':
   include (SN_PathRoot.'inc/db/mssql.php');
   break;
case 'msaccess':
   include (SN_PathRoot.'inc/db/msaccess.php');
   break;
case 'mssql-odbc':
   include (SN_PathRoot.'inc/db/mssql-odbc.php');
   break;
default:
   die ('<br><br><center><br><br><b>Извините, но в данный момент существует проблема с подключением к '.$conf['dbtype'].' серверу.<br><br>Приносим свои извинения, просим Вас зайти немного позже.</center></b>');
}
$db = new sql_db ($db_conf['dbhost'], $db_conf['dbuname'], $db_conf['dbpass'], $db_conf['dbname'], false);
if (!$db->db_connect_id) {
    die ('<br><br><center><br><br><b>Извините, но в данный момент существует проблема с подключением к '.$conf['dbtype'].' серверу.<br><br>Приносим свои извинения, просим Вас зайти немного позже.</center></b>');
}
//unset ($conf['dbhost'], $conf['dbname'], $conf['dbuname'], $conf['dbpass']);
//unset ($db_conf['dbpass'], $conf['dbpass']);

// Инициализация темплатов
include (SN_PathRoot.'inc/function/template.php');
$template = new Template (SN_PathRoot.'template/'.$conf['default_design']);

// Активация виз. редактора
if (($conf['allow_redaktor'] == 1) && defined ('SN_SiteSystemAdmin')) {
   include (SN_PathRootAdmin.'redaktor/spaw_control.class.php');
}

// Инициализации сесий пользователей
include (SN_PathRoot.'inc/function/sessions.php');
session_name ("SNS");
session_start ();

// Выбор и переключение языков
if ($conf['multi_lang'] == 1) {
   if ((!isset ($_SESSION['snss_lang'])) AND (isset($_COOKIE['snss_lang']))) {
      session_register ("snss_lang");
      $_SESSION['snss_lang'] = $conf['default_lang'];
      if ($_COOKIE['snss_lang'] != "") {
         $_SESSION['snss_lang'] = $_COOKIE['snss_lang'];
      } else {
         $_SESSION['snss_lang'] = $conf['default_lang'];
      }
   }
   if (!isset ($_SESSION['snss_lang'])) {
      session_register ("snss_lang");
      $_SESSION['snss_lang'] = $conf['default_lang'];
   }
   if (isset ($_GET['newlang']) || isset ($_POST['newlang']) ) {
      $newlang = trim ((isset ($_POST['newlang'])) ? $_POST['newlang'] : $_GET['newlang']);
      if ($newlang != '' AND !eregi ("[^a-z]", $newlang)) {
         $_SESSION['snss_lang'] = $newlang;
         setcookie ("snss_lang", "$newlang", time ()+$conf['live_cookie_time'], $conf['cookie_path'], $conf['cookie_domain']);
      }
   }
   define ('_SNSS_LANG',''.$_SESSION['snss_lang'].'');
} else {
   $_SESSION['snss_lang'] = $conf['default_lang'];
   define ('_SNSS_LANG',''.$conf['default_lang'].'');
}

// Проверка на бан
$banned_ip = file (SN_PathRoot.'inc/banned_ip.dat');
if (isset ($_COOKIE['snss_ban']) == "lqwkdh2378db1278bcd") { define ('Ban_Cookie', true); }
if ($user['user_ip'] != '') {
   foreach ($banned_ip as $banip) {
      if ($user['user_ip'] == trim ($banip)) { define ('Ban_Ip', true); }
   }
}
if ((defined ('Ban_Cookie')) OR (defined ('Ban_Ip'))) {
   setcookie ("snss_ban", "lqwkdh2378db1278bcd", time () + 31536000, "/");
   $lang = ((defined ('SN_SiteSystemAdmin')) ? SN_PathRootAdmin : SN_PathRoot).'lang/lang-'._SNSS_LANG.'.php';
   if (file_exists ($lang)) {
      include_once ($lang);
   } else {
      echo ('Eror! Lang file is absent');
      exit;
   }
   echo "<html>\n"
   ."<head>\n"
   ."<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset="._CHARSET."\">\n"
   ."<title>"._ACCESSBAN."</title>\n"
   ."</head>\n"
   ."<body>\n"
   ."<h1>"._ACCESSBAN."</h1>\n"
   ."</body>\n"
   ."</html>\n";
   exit;
}

unset ($matches);
unset ($loc);
if (preg_match ("/([OdWo5NIbpuU4V2iJT0n]{5}) /", rawurldecode ($loc = $_SERVER["QUERY_STRING"]), $matches)) {
   header ('Location: index.php');
   exit;
}
$queryString = strtolower ($_SERVER['QUERY_STRING']);
if (stripos_clone ($queryString,'%20union%20') OR stripos_clone ($queryString,'/*') OR stripos_clone ($queryString,'*/union/*') OR stripos_clone ($queryString,'c2nyaxb0')) {
   header ('Location: index.php');
   exit;
}

// Буферизация и компресия (начало)
$do_gzip_compress = FALSE;
if ($conf['gzip_method'] == 1) {
   $phpver = phpversion ();
   if ($phpver >= '4.0.4pl1' && (strstr ($user['user_agent'], 'compatible') || strstr ($user['user_agent'], 'Gecko'))) {
      if (extension_loaded ('zlib')) { @ob_start ('ob_gzhandler'); }
   } else if ($phpver > '4.0') {
      if (strstr ($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')) {
         if (extension_loaded ('zlib')) {
            $do_gzip_compress = TRUE;
            ob_start ();
            ob_implicit_flush (0);
            header ('Content-Encoding: gzip');
         }
      }
   }
} else {
   ob_start();
}

if (defined ('SN_SiteSystem')) {
   $handle = @opendir ('inc/add_function');
   while (false !== ($file = @readdir ($handle))) {
      if (false === strpos ($file, '.php')) { continue; }
      include_once (SN_PathRoot.'inc/add_function/'.$file);
   }
   @closedir ($handle);
}
?>