<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: function.php
# Path: inc/function/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2008 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: all_function.php
# Path: inc/
# Data: 29.10.2008
# Version: 2.0.4
######################################################################
if ((!defined ('SN_SiteSystem')) AND (!defined ('SN_SiteSystemAdmin'))) { Header ('Location: ../index.php'); exit; }

function stripos_clone ($haystack, $needle, $offset=0) {
   return strpos (strtoupper ($haystack), strtoupper ($needle), $offset);
}

// Загрузка настроек системы/модулей/блоков
function load_config ($name = '', $type = 'module') {
   $name = ($name == '' AND $type == 'module' AND $type != 'system')? SN_ModuleName : $name ;
   $type_conf = array (
      'system' => SN_PathRoot.'inc/configs/system.php',
      'module' => SN_PathRoot.'inc/configs/'.$name.'-mod.php',
      'block' => SN_PathRoot.'inc/configs/'.$name.'-block.php',
      );
   if (!isset ($type_conf[$type])) { return false; }
   if (file_exists ($type_conf[$type])) {
      if ($file = @fopen ($type_conf[$type], 'r')) {
         $i = 0;
         while (!flock ($file, 1)) {
            sleep (1);
            $i++;
            if ($i >= 8) { return false; }
         }
         @fseek ($file, 8);
         $cfg = @fread ($file, filesize ($type_conf[$type])-8);
         @fclose ($file);
         return unserialize ($cfg);
      }
   }
   return false;
}

function load_const ($name = '') {
   global $conf, $db_conf;
   $name = SN_PathRoot.'modules/'.(($name == '')? SN_ModuleName : $name).'/core/constants.php';
   if (!file_exists ($name)) { return false; }
   include_once ($name);
}

//функция подключения языков
function load_lang ($name = '', $lang='', $type = 'module') {
   $name = ($name == '' AND $type == 'module' AND $type != 'system')? 'main' : $name ;
   $path = (defined ('SN_SiteSystemAdmin'))? SN_PathRootAdmin : SN_PathRoot ;
   $type_conf = array (
      'system' => $path.'lang/'._SNSS_LANG.'/lang-main.php',
      'module' => $path.'modules/'.SN_ModuleName.'/lang/'._SNSS_LANG.'/lang-'.$name.'.php',
      'block' => $path.'lang/'._SNSS_LANG.'/blocks/lang-'.$name.'.php',
      );
   if (!isset ($type_conf[$type])) { return false; }
   if (file_exists ($type_conf[$type])) {
      include ($type_conf[$type]);
      return $lang;
   }
   return false;
}

function url ($str_url='', $absolute = false, $module = '') {
   if (strstr (urldecode ($str_url), "\n") || strstr (urldecode ($str_url), "\r")){
      eror ('Bed format');
   }
   if (!$absolute) {
      return (defined ('SN_SiteSystemAdmin'))? SN_UrlRootAdmin.'admin.php?go='.(('' == $module)? SN_ModuleName : $module).$str_url : SN_UrlRoot.'index.php?go='.(('' == $module)? SN_ModuleName : $module).$str_url;
   } else {
      return (defined ('SN_SiteSystemAdmin'))? SN_UrlRootAdmin.(('' != $module)? 'admin.php?go='.$module : '').$str_url : SN_UrlRoot.(('' != $module)? 'index.php?go='.$module : '').$str_url;
   }
   return false;
}

function redirect ($str_url='', $absolute = false, $module = '') {
   Header ('Location: '.url ($str_url, $absolute, $module));
   exit;
}

function inc_lang() {
    global $conf;
    if ((defined('_SNSS_LANG'))  AND !eregi("\.", _SNSS_LANG)) {
    if (file_exists("modules/".SN_ModuleName."/lang/lang-"._SNSS_LANG.".php")) {
    include_once("modules/".SN_ModuleName."/lang/lang-"._SNSS_LANG.".php");
    }  else {
    eror("Eror! Lang file is absent");
    }
    }
    else if(!defined('_SNSS_LANG')) {
    if (file_exists("modules/".SN_ModuleName."/lang/lang-".$conf['default_lang'].".php")) {
    include_once("modules/".SN_ModuleName."/lang/lang-".$conf['default_lang'].".php");
    } else {
    eror("Eror! Lang file no exist");
    }
    }
}

function eror ($eror_text) {
   global $header_mod_title;
   $header_mod_title = _EROR;
   include (SN_PathRoot.'header.php');
   $template->set_filenames (array (
      'page_eror' => 'page_eror.tpl')
   );
   $template->assign_vars (array (
      'L_EROR' => _EROR,
      'L_ERORTEXT' => $eror_text,
      'L_GOBACK' => _GOBACK)
   );
   $template->pparse ('page_eror');
   include (SN_PathRoot.'footer.php');
   exit;
}

function select_lang ($wh) {
    $querylang = "$wh (view_lang = '"._SNSS_LANG."' OR view_lang='')";
    return $querylang;
}

function createpassword () {
    $cons = "bcdfghjklmnpqrstvwxyz";
    $bons = "BCDFGHJKLMNPGRSTVWXYZ";
    $vocs = "aeiou";
    $noms = "123456789";
    for ($x=0; $x < 6; $x++) {
    mt_srand ((double) microtime() * 1000000);
    $con[$x] = substr($cons, mt_rand(0, strlen($cons)-1), 1);
    $bon[$x] = substr($bons, mt_rand(0, strlen($bons)-1), 1);
    $voc[$x] = substr($vocs, mt_rand(0, strlen($vocs)-1), 1);
    $nom[$x] = substr($noms, mt_rand(0, strlen($noms)-1), 1);
    }
    $makepass = $con[0] . $voc[3] . $con[1] . $nom[2] . $nom[5] .$bon[2] . $con[4];
    return($makepass);
}


function title () {
    global $template, $header_mod_title;
    $template->set_filenames(array(
        "page_title" => "page_title.tpl")
    );
    $template->assign_vars(array(
        "PAGE_TITLE" => $header_mod_title)
    );
    $template->pparse("page_title");
}

function stripslashesfix ($what = "") {
    $what = ereg_replace("'","''",$what);
    while (eregi("\\\\'", $what)) {
    $what = ereg_replace("\\\\'","'",$what);
    }
    return $what;
}

function replace ($string) {
    $string = stripslashes($string);
    $string = ereg_replace("::","&#58;&#58;",$string);
    $string = ereg_replace("!","&#33;",$string);
    $string = ereg_replace("\r\n"," ",$string);
    $string = ereg_replace("%","&#37;",$string);
    $string = ereg_replace("^ +","",$string);
    $string = ereg_replace(" +$","",$string);
    $string = ereg_replace(" +"," ",$string);
    return $string;
}

function formatdate ($format, $datatime) {
    global $conf;
    static $translate;

    $lang['datetime']['Sunday'] = _SUNDAY;
    $lang['datetime']['Monday'] = _MONDAY;
    $lang['datetime']['Tuesday'] = _TUESDAY;
    $lang['datetime']['Wednesday'] = _WEDNESDAY;
    $lang['datetime']['Thursday'] = _THURSDAY;
    $lang['datetime']['Friday'] = _FRIDAY;
    $lang['datetime']['Saturday'] = _SATURDAY;
    $lang['datetime']['Sun'] = _SUN;
    $lang['datetime']['Mon'] = _MON;
    $lang['datetime']['Tue'] = _TUE;
    $lang['datetime']['Wed'] = _WED;
    $lang['datetime']['Thu'] = _THU;
    $lang['datetime']['Fri'] = _FRI;
    $lang['datetime']['Sat'] = _SAT;
    $lang['datetime']['January'] = _JANUARY;
    $lang['datetime']['February'] = _FEBRUARY;
    $lang['datetime']['March'] = _MARCH;
    $lang['datetime']['April'] = _APRIL;
    $lang['datetime']['May'] = _MAYA;
    $lang['datetime']['June'] = _JUNE;
    $lang['datetime']['July'] = _JULY;
    $lang['datetime']['August'] = _AUGUST;
    $lang['datetime']['September'] = _SEPTEMBER;
    $lang['datetime']['October'] = _OCTOBER;
    $lang['datetime']['November'] = _NOVEMBER;
    $lang['datetime']['December'] = _DECEMBER;
    $lang['datetime']['Jan'] = _JAN;
    $lang['datetime']['Feb'] = _FEB;
    $lang['datetime']['Mar'] = _MAR;
    $lang['datetime']['Apr'] = _APR;
    $lang['datetime']['May'] = _MAY;
    $lang['datetime']['Jun'] = _JUN;
    $lang['datetime']['Jul'] = _JUL;
    $lang['datetime']['Aug'] = _AUG;
    $lang['datetime']['Sep'] = _SEP;
    $lang['datetime']['Oct'] = _OCT;
    $lang['datetime']['Nov'] = _NOV;
    $lang['datetime']['Dec'] = _DEC;

    if (empty($translate) && _SNSS_LANG != 'en') {
    @reset($lang['datetime']);
    while ( list($match, $replace) = @each($lang['datetime']) ) {
    $translate[$match] = $replace;
    }
    }
    return ( !empty($translate) ) ? strtr(@gmdate($format, $datatime + (3600 * $conf['time_zone'])), $translate) : @gmdate($format, $datatime + (3600 * $conf['time_zone']));
}

function generate_page ($base_url, $num_items, $per_page, $start_item, $add_prevnext_text = TRUE) {
    $total_pages = ceil($num_items/$per_page);
    if ($total_pages == 1) { return ''; }

    @$on_page = floor($start_item / $per_page) + 1;
    $page_string = '';
    if($total_pages > 10) {
    $init_page_max = ($total_pages > 3) ? 3 : $total_pages;
    for($i = 1; $i < $init_page_max + 1; $i++) {
    $page_string .= ($i == $on_page) ? '<b>'.$i.'</b>' : '<a href="'.$base_url."&amp;page=".(($i - 1) * $per_page).'">'.$i.'</a>';
    if ($i <  $init_page_max) { $page_string .= ", "; }
    }
    if ($total_pages > 3) {
    if ($on_page > 1  && $on_page < $total_pages) {
    $page_string .= ($on_page > 5) ? ' ... ' : ', ';
    $init_page_min = ($on_page > 4) ? $on_page : 5;
    $init_page_max = ($on_page < $total_pages - 4) ? $on_page : $total_pages - 4;
    for($i = $init_page_min - 1; $i < $init_page_max + 2; $i++) {
    $page_string .= ($i == $on_page) ? '<b>'.$i.'</b>' : '<a href="'.$base_url. "&amp;page=" .(($i - 1) * $per_page).'">'.$i.'</a>';
    if ($i <  $init_page_max + 1) { $page_string .= ', '; }
    }
    $page_string .= ($on_page < $total_pages - 4) ? ' ... ' : ', ';
    }
    else { $page_string .= ' ... '; }

    for($i = $total_pages - 2; $i < $total_pages + 1; $i++) {
    $page_string .= ($i == $on_page) ? '<b>'.$i.'</b>'  : '<a href="'.$base_url. "&amp;page=" . (($i - 1) * $per_page).'">'.$i.'</a>';
    if( $i <  $total_pages ) { $page_string .= ", "; }
    }
    }
    } else {
    for($i = 1; $i < $total_pages + 1; $i++) {
    $page_string .= ($i == $on_page) ? '<b>'.$i.'</b>' : '<a href="'.$base_url. "&amp;page=" . (($i - 1) * $per_page).'">'.$i.'</a>';
    if ($i <  $total_pages) { $page_string .= ', '; }
    }
    }
    if ($add_prevnext_text) {
    if ($on_page > 1) {
    $page_string = ' <a href="'.$base_url. "&amp;page=" . (($on_page - 2) * $per_page).'">'. _PAGEPREV.'</a>&nbsp;&nbsp;' . $page_string;
    }
    if ($on_page < $total_pages) {
    $page_string .= '&nbsp;&nbsp;<a href="'.$base_url. "&amp;page=" . ($on_page * $per_page).'">'. _PAGENEXT.'</a>';
    }
    }
    $page_string = _PAGESNUM . ' ' . $page_string;
    return $page_string;
}
///////////////////////////// коментарии 
/*
function include_comments ($pc_id, $pc_url, $mod_table, $mod_com_table) {
    global $conf, $template, $db, $user;
    $conf['code_dis'] = 0;
    if ($conf['allow_comments'] == 1) {

        if ($user['member_id'] > 0) {
            $author = $user['member_login'];
        }
        else {
            $author = _ANONIMUS;
        }

        if ($conf['smiles_comments'] == 1) {
            for ($i=1; $i<=16; $i++) {
                $smiles_code[] = "::$i::";
                $smiles_pic[] = " <IMG src=\"images/smiles/$i.gif\" border=\"0\"> ";
            }
        }

        $template->set_filenames(array(
            'comments' => 'comments.tpl')
        );

        $sql = "SELECT title, comments_count FROM ".$conf['prefix']."_".$mod_table." WHERE id = '$pc_id'";
        $result = $db->sql_query ($sql);
        $row = $db->sql_fetchrow ($result);

        $template->assign_vars (array (
            'L_COMMENTS' => _COMMENTS,
            'COMMENTS_COUNT' => intval($row['comments_count'])
        ));

        if (isset($_POST['act']) == '1') {

            $author = trim(strip_tags($_POST['author']));
            $title = trim(strip_tags(stripslashes($_POST['title'])));
            $text =  trim(nl2br(strip_tags(stripslashes($_POST['text']))));
            $code = (isset ($_POST['code']))? trim (strip_tags ($_POST['code'])) : '';

            if (!$conf['code_dis'] AND (((isset ($_SESSION['ModMembersCode'])? trim ($_SESSION['ModMembersCode']) : '') != $code) OR ('' == $code))) {
                $send_com_eror = _NOALLFIELDS;
            }

            if (($author == "") || ($title == "") || ($text == "")) {
                $send_com_eror = _NOALLFIELDS;
            }

            if ((strlen($text)) > $conf['max_post_simbol']) {
                $send_com_eror = ""._NOPOSTMANYS." ".$conf['max_post_simbol']."";
            }

            $e = explode(" ", $text);
            if(count($e) > 1) {
                for ($a = 0; $a < count($e); $a++) {
                    $o = strlen($e[$a]);
                    if ($o > $conf['max_word_simbol']) { $send_com_eror = ""._NOWORDSMANYS." ".$conf['max_word_simbol'].""; }
                }
            }
            else {
                if (strlen($e[0]) > $conf['max_word_simbol']) {
                $send_com_eror = ""._NOWORDSMANYS." ".$conf['max_word_simbol']."";
                }
            }

            if ($conf['post_flud_time'] != 0) {
                if (((isset($_SESSION['com_flud_time'])+$conf['post_flud_time']) > time()) OR (isset($_COOKIE['snss_com_flud']) == 'lqwkdh2378db1278bcd')) {
                    $send_com_eror = ''._COMFLUDTIME.' '.$conf['post_flud_time'].' '._SEC.'';
                }
            }

            if (isset($send_com_eror)) {
                // Вывод ошибки
                $template->assign_block_vars('erorsend', array(
                    'L_EROR_COM_SEND' => $send_com_eror
                ));
                // Формирование формы
                $template->assign_block_vars('postform', array(
                    'L_YOUR_NAME' => _YOURNAME,
                    'YOUR_NAME' => $author,
                    'S_FORM_ACTION' => $pc_url,
                    'L_ADD_COMMENT' => _ADDCOMMENT,
                    'COM_TITLE' => $title,
                    'COM_TEXT' => strip_tags($text)
                ));
                // Смайлы
                if ($conf['smiles_comments'] == 1) {
                    $template->assign_block_vars('postform.smiles', array(
                        'L_EMOCION' => _COMEMOTIONS
                    ));
                }
                // Код визуализации.
                if (!$conf['code_dis']) {
                   include (SN_PathRoot.'inc/function/kcaptcha.php');
                   $captcha = new KCAPTCHA ();
                   $template->assign_block_vars ('postform.code', array (
                      'I_CODE' => url ('&in=code', false, 'Members'),
                   ));
                   $_SESSION['ModMembersCode'] = $captcha->getKeyString ();
                }
            }
            else {

                $postdate = time();
                $ip = $_SERVER['REMOTE_ADDR'];
                $save_com = $db->sql_query("INSERT INTO ".$conf['prefix']."_".$mod_com_table." (com_id, id, ip, author, date, title, text)
                VALUES (NULL, '$pc_id', '$ip', '$author', '$postdate', '$title', '$text')");

                if ($save_com) {
                    $db->sql_query("UPDATE ".$conf['prefix']."_".$mod_table." SET comments_count = comments_count+1  WHERE id = '$pc_id'");

                    if ($conf['post_flud_time'] != 0) {
                        $_SESSION['com_flud_time'] = time();
                        setcookie ("snss_com_flud", "lqwkdh2378db1278bcd", time()+$conf['post_flud_time']);
                    }

                    if ($conf['post_mail_comments'] == '1') {
                         $subject = _NEWCOMSITE;
                         $msg = ""._YOURSITE." ".$conf['site_name']." "._ADDNEWCOMMENT."\n\n";
                         $msg .= ""._COMAUTHOR.": $author | $ip\n\n";
                         $msg .= "".$title."\n".strip_tags($text)."\n\n";
                         $msg .= "".$conf['site_url']."/".$pc_url."\n\n";
                         $to = $conf['admin_mail'];
                         $mailheaders = "Content-Type: text/plain; charset="._CHARSET."\n";
                         $mailheaders .= "From: ".$conf['site_name']." <".$conf['admin_mail'].">\n";
                         mail ($to, $subject, $msg, $mailheaders);
                    }
                }

            Header ('Location: '.$pc_url.'');
            }
        }
        else {

            if (($conf['anonim_comments'] == 0) AND (0 > $user['user_id'])) {
                $template->assign_block_vars('noanonimpost', array(
                    'L_COMMENT_ANONIM' => _NOANONIMCOM
                ));
            }
            else {
                // Формирование формы
                $template->assign_block_vars('postform', array(
                    'L_YOUR_NAME' => _YOURNAME,
                    'YOUR_NAME' => $author,
                    'S_FORM_ACTION' => $pc_url,
                    'COM_TITLE' => 'Re: '.$row['title'].'',
                    'L_ADD_COMMENT' => _ADDCOMMENT
                ));
                // Смайлы
                if ($conf['smiles_comments'] == 1) {
                    $template->assign_block_vars('postform.smiles', array(
                        'L_EMOCION' => _COMEMOTIONS
                    ));
                }
                // Код визуализации.
                if (!$conf['code_dis']) {
                   include (SN_PathRoot.'inc/function/kcaptcha.php');
                   $captcha = new KCAPTCHA ();
                   $template->assign_block_vars ('postform.code', array (
                      'I_CODE' => url ('&in=code', false, 'Members'),
                   ));
                   $_SESSION['ModMembersCode'] = $captcha->getKeyString ();
                }
            }

            $page = ( isset($_GET['page']) ) ? intval($_GET['page']) : 0;
            $num = $db->sql_fetchrow($db->sql_query("SELECT COUNT(*) FROM ".$conf['prefix']."_".$mod_com_table." WHERE id = '$pc_id'"));
            $all_page = ($num['COUNT(*)']) ? $num['COUNT(*)'] : 1;

            $sql = "SELECT * FROM ".$conf['prefix']."_".$mod_com_table." WHERE id = '$pc_id' ORDER BY com_id DESC LIMIT $page, ".$conf['comments_page']."";
            $result = $db->sql_query($sql);
            while ($row = $db->sql_fetchrow ($result)) {

                $comment_text = $row['text'];

                if ($conf['smiles_comments'] == 1) {
                    for ($j = 0; $j < 16; $j++){
                        $comment_text = str_replace($smiles_code[$j], $smiles_pic[$j], $comment_text);
                    }
                }

                $template->assign_block_vars('viewcomments', array(
                    'COMAUTHOR' => $row['author'],
                    'COMDATE' => formatdate("d.m.Y H:i", $row['date']),
                    'COMTITLE' => $row['title'],
                    'COMTEXT' => $comment_text
                    ));
            }

            $template->assign_vars(array(
                'PAGINATION' => generate_page($pc_url, $all_page, $conf['comments_page'], $page)
            ));
        }

        $template->pparse("comments");
    }
}
*/
/// end коментарии

function num_in_words ($n, $s){
    $n = abs($n);
    $a = split(",", $s);
    $l1 = $n-((int)($n/10))*10;
    $l2 = $n-((int)($n/100))*100;
    if(11<=$l2 AND $l2<=14) {
    $e=$a[2];
    } else {
    if($l1==1) $e=$a[0];
    if(2<=$l1 AND $l1<=4) $e=$a[1];
    if((5<=$l1 AND $l1<=9) or $l1==0) $e=$a[2];
    }
    if($e=="") $e=$a[0];
    return($e);
}

?>
