<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: sessions.php
# Path: inc/
# Version: 2.0.4
######################################################################
if ((!defined('SN_SiteSystem')) AND (!defined('SN_SiteSystemAdmin'))) { Header('Location: ../index.php'); exit; }

function sess_open ($save_path, $session_name) {
   global $conf;
   sess_gc ($conf['live_cookie_time']);
   return true;
}

function sess_close () {
   return true;
}

function sess_read ($session_id) {
   global $db, $user, $session;
   if (strlen ($session_id) != 32) {
      error_log  ("sess_read(): Invalid SessionID = ".$session_id);
      return '';
   }
   $sql = "SELECT u.*, s.* FROM `".SN_SESSIONS_TABLE."` AS s, `".SN_MEMBERS_TABLE."` AS u WHERE s.`session_id` = '".$db->sql_escape ($session_id)."' AND s.`sessions_user_id` = u.`user_id`";
   $result = $db->sql_query ($sql);
   if ($db->sql_numrows ($result) == 1) {
      $session = $db->sql_fetchrow ($result);
      if ($session AND $session['session_ip'] == $user['user_ip'] AND $session['session_agent'] == $user['user_agent']) {
         //unset($session['session_data']);
         $user = array_merge ($user, $session);
         unset($user['session_data']);
         return $session['session_data'];
      } else {
         session_destroy ();
         return '';
      }
   } elseif (!$result) {
      $result = $db->sql_error ($result);
      error_log ('sess_read(): Failed to read sessions - '.$result['message']);
      return '';
   } else {
      $session = null;
      return '';
   }
}

function sess_write ($session_id, $session_data) {
   global $db, $user, $session;
   if (strlen ($session_id) != 32) {
      error_log ('sess_write(): Invalid Session ID = '.$session_id);
      return false;
   }
   if (strlen ($session_data) > 65535) {
      error_log ('sess_write(): Session data too large. '.$session_id);
   }
   if ($session AND $session['session_ip'] != $user['user_ip']){
      session_destroy ();
      return '';
   }
   $session_data = $db->sql_escape ($session_data);
   if ($session) {
      $sql = "UPDATE `".SN_SESSIONS_TABLE."` SET `sessions_user_id` = '".intval ($session['sessions_user_id'])."', `session_last` = '".time ()."', `session_counter` = '". ++$session['session_counter'] ."', `session_data` = '".$session_data."' WHERE `session_id` = '".$db->sql_escape ($session_id)."'";
   } else {
      $sql = "INSERT INTO `".SN_SESSIONS_TABLE."` (`session_id`, `session_created`, `session_last`, `session_ip`, `session_agent`, `session_data`) VALUES ('$session_id', ".time().", ".time().", '".$db->sql_escape ($user['user_ip'])."', '".$db->sql_escape ($user['user_agent'])."', '".$session_data."')";
   }
   $result = $db->sql_query ($sql);
   if (!$result) {
      $result = $db->sql_error ($result);
      error_log ('sess_write(): Failed to INSERT/UPDATE session. '.$result['message']."<br> Query: ".$sql);
   }
   return true;
}

function sess_destroy ($session_id) {
   global $db;
   $sql = "DELETE FROM `".SN_SESSIONS_TABLE."` WHERE `session_id` = '".$db->sql_escape ($session_id)."'";
   $result = $db->sql_query ($sql);
   if (!$result) {
      $result = $db->sql_error ($result);
      error_log ('sess_destory(): Failed to DELETE session. '.$result['message']);
      return false;
   }
   return true;
}

function sess_gc ($sess_gc_maxlifetime=60) {
   global $db;
   $sql = "DELETE FROM `".SN_SESSIONS_TABLE."` WHERE `session_last` < ".(time () - $sess_gc_maxlifetime);
   $result = $db->sql_query ($sql);
   if (!$result) {
      $result = $db->sql_error ($result);
      error_log ('sess_gc(): Failed to DELETE old sessions.'.$result['message']);
      return false;
   }
   return true;
}

if (version_compare ('5', PHP_VERSION, '<')) {
    ini_set ('session.hash_bits_per_character', '4');
    ini_set ('session.hash_function', '0');
}
ini_set ('session.gc_maxlifetime', $conf['live_cookie_time']);
session_set_cookie_params (0, $conf['cookie_path'], $conf['cookie_domain'], false);
session_cache_limiter ('nocache');
session_set_save_handler ('sess_open', 'sess_close', 'sess_read', 'sess_write', 'sess_destroy', 'sess_gc');
ini_set ('session.save_handler', 'user');
register_shutdown_function ('session_write_close');
//session_name ("SNS");
?>