######################################################################
# SchoolNuke 2.0:   
# Module: Install
# File: mysql_schema.sql
# Path: install/
# ============================================
# Copyright (c) 2009   
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
#     
#  . ..
#  - 2009.
# ============================================
#      .
#     /       2
#             GNU,
#  Free Software Foundation.
#      ,     ,
#    ,    
#            .
#           GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Install
# File: mysql_schema.sql
# Path: install/
# Version: 2.0.4
######################################################################

DROP TABLE IF EXISTS `school_admins`;
CREATE TABLE IF NOT EXISTS `school_admins` (
  `admin_id` int(11) NOT NULL auto_increment,
  `login` varchar(15) NOT NULL,
  `admin_fullname` varchar(50) NOT NULL,
  `lesson` text NOT NULL,
  `password` varchar(40) NOT NULL default '',
  `checknum` varchar(40) NOT NULL default '',
  `last_login` int(11) default NULL,
  `last_ip` varchar(15) NOT NULL default '',
  `agent` varchar(80) NOT NULL default '',
  `email` varchar(50) NOT NULL default '',
  `access` text NOT NULL,
  PRIMARY KEY  (`admin_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

DROP TABLE IF EXISTS `school_blocks`;
CREATE TABLE IF NOT EXISTS `school_blocks` (
  `block_id` int(11) NOT NULL auto_increment,
  `title_ru` varchar(255) NOT NULL default '',
  `title_en` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `file_name` varchar(255) NOT NULL default '',
  `in_module` varchar(100) NOT NULL default '',
  `no_module` varchar(100) NOT NULL default '',
  `position` char(1) NOT NULL default '',
  `weight` int(10) NOT NULL default '0',
  `view` int(1) NOT NULL default '0',
  `language` varchar(20) NOT NULL default '',
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`block_id`),
  KEY `position` (`position`),
  KEY `status` (`status`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;


DROP TABLE IF EXISTS `school_members`;
CREATE TABLE IF NOT EXISTS `school_members` (
  `user_id` int(11) NOT NULL auto_increment,
  `username` varchar(25) NOT NULL default '',
  `user_group` varchar(5) NOT NULL,
  `user_curriculum` int(2) NOT NULL,
  `user_email` varchar(255) NOT NULL default '',
  `user_fullname` varchar(50) NOT NULL,
  `user_regdate` int(11) NOT NULL default '0',
  `user_password` varchar(40) NOT NULL default '',
  `user_actkey` varchar(32) default NULL,
  `user_newpasswd` varchar(32) default NULL,
  `user_last_agent` varchar(100) NOT NULL default '',
  `user_last_ip` varchar(15) NOT NULL default '0',
  `user_last_date` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`),
  KEY `username` (`username`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `school_modules`;
CREATE TABLE IF NOT EXISTS `school_modules` (
  `mod_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `title_ru` varchar(255) NOT NULL default '',
  `title_en` varchar(255) NOT NULL default '',
  `view` int(1) NOT NULL default '0',
  `status` int(1) NOT NULL default '0',
  `theme` int(1) NOT NULL default '0',
  `link` int(1) NOT NULL default '0',
  `position` int(11) NOT NULL default '0',
  `line` int(1) NOT NULL default '0',
  PRIMARY KEY  (`mod_id`),
  KEY `mod_id` (`mod_id`),
  KEY `title` (`title`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;


DROP TABLE IF EXISTS `school_sessions`;
CREATE TABLE IF NOT EXISTS `school_sessions` (
  `session_id` varchar(32) NOT NULL default '',
  `sessions_user_id` int(11) NOT NULL default '-1',
  `session_created` int(11) NOT NULL default '0',
  `session_last` int(11) NOT NULL default '0',
  `session_counter` int(11) NOT NULL default '0',
  `session_ip` varchar(15) NOT NULL default '',
  `session_agent` varchar(100) NOT NULL default '',
  `session_data` longtext NOT NULL,
  PRIMARY KEY  (`session_id`),
  KEY `sessions_user_id` (`sessions_user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


######################################################################
# Module: About
# Version: 0.1
######################################################################

DROP TABLE IF EXISTS `school_mod_about`;
CREATE TABLE IF NOT EXISTS `school_mod_about` (
  `lang` char(3) NOT NULL default '',
  `title` varchar(100) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `keywords` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `status` int(1) NOT NULL default '0',
  `date` int(11) default NULL,
  PRIMARY KEY  (`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


######################################################################
#
#
######################################################################

DROP TABLE IF EXISTS `school_allow`;
CREATE TABLE IF NOT EXISTS `school_allow` (
  `allow_id` int(11) NOT NULL auto_increment,
  `id_user` int(11) NOT NULL,
  `lesson` varchar(5) NOT NULL,
  `allows` int(11) NOT NULL,
  `variant` int(2) NOT NULL default '99',
  PRIMARY KEY  (`allow_id`),
  KEY `id_user` (`id_user`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `school_group`;
CREATE TABLE IF NOT EXISTS `school_group` (
  `group_id` int(11) NOT NULL auto_increment,
  `groups` varchar(8) NOT NULL,
  `curriculum` int(2) NOT NULL default '0',
  `groupname` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`group_id`),
  KEY `username` (`groups`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `school_journal`;
CREATE TABLE IF NOT EXISTS `school_journal` (
  `journal_id` int(11) NOT NULL auto_increment,
  `id_table` int(11) NOT NULL,
  `id_user` int(4) NOT NULL,
  `username` varchar(25) NOT NULL,
  `user_fullname` varchar(50) NOT NULL,
  `lesson` varchar(5) NOT NULL,
  `lessonname` varchar(50) NOT NULL,
  `id_level` int(11) NOT NULL,
  `levelname` varchar(25) NOT NULL,
  `times` datetime NOT NULL,
  `results` int(1) default '0',
  `percent` float default '0',
  `new_result` varchar(50) NOT NULL,
  `comments` longtext NOT NULL,
  UNIQUE KEY `journal_id` (`journal_id`),
  KEY `username` (`username`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `school_lesson`;
CREATE TABLE IF NOT EXISTS `school_lesson` (
  `lesson_id` int(11) NOT NULL auto_increment,
  `lesson` varchar(5) NOT NULL,
  `lessonname` varchar(50) NOT NULL,
  PRIMARY KEY  (`lesson_id`),
  KEY `lessonname` (`lessonname`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `school_level`;
CREATE TABLE IF NOT EXISTS `school_level` (
  `level_id` int(11) NOT NULL auto_increment,
  `levels` int(5) NOT NULL,
  `levelname` varchar(50) NOT NULL,
  `id_table` int(11) NOT NULL,
  `curriculum` int(2) NOT NULL,
  `lesson` varchar(5) NOT NULL,
  `skriptname` varchar(25) NOT NULL,
  `status` varchar(10) NOT NULL,
  PRIMARY KEY  (`level_id`),
  KEY `levels` (`levels`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `school_table`;
CREATE TABLE IF NOT EXISTS `school_table` (
  `table_id` int(11) NOT NULL auto_increment,
  `tablename` varchar(5) NOT NULL,
  `tablefullname` varchar(100) NOT NULL,
  `lesson` varchar(5) NOT NULL,
  `curriculum` int(2) NOT NULL,
  `tables` varchar(30) NOT NULL,
  `tables_task` varchar(30) NOT NULL,
  `tables_answer` varchar(30) NOT NULL,
  `tables_log` varchar(30) NOT NULL,
  `skriptname` varchar(25) NOT NULL,
  PRIMARY KEY  (`table_id`),
  KEY `tables` (`tables`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

